Main Page Class List Class Members

# Nv::Blast::VoronoiSitesGenerator Class Reference

`#include <NvBlastExtAuthoringFractureTool.h>`

Inheritance diagram for Nv::Blast::VoronoiSitesGenerator:

List of all members.

## Public Member Functions
virtual void | addSite (const NvcVec3 &site)=0
virtual void | clearStencil ()=0
virtual void | clusteredSitesGeneration (uint32_t numberOfClusters, uint32_t sitesPerCluster, float clusterRadius)=0
virtual void | deleteInSphere (const float radius, const NvcVec3 &center, const float eraserProbability=1)=0
virtual void | generateInSphere (const uint32_t count, const float radius, const NvcVec3 &center)=0
virtual uint32_t | getVoronoiSites (const NvcVec3 *&sites)=0
virtual void | radialPattern (const NvcVec3 &center, const NvcVec3 &normal, float radius, int32_t angularSteps, int32_t radialSteps, float angleOffset=0.0f, float variability=0.0f)=0
virtual void | release ()=0
virtual void | setBaseMesh (const Mesh *mesh)=0
virtual void | setStencil (const Mesh *stencil)=0
virtual void | uniformlyGenerateSitesInMesh (uint32_t numberOfSites)=0
virtual | ~VoronoiSitesGenerator ()

## Detailed Description

Class for voronoi sites generation inside supplied mesh.

## Constructor & Destructor Documentation

virtual Nv::Blast::VoronoiSitesGenerator::~VoronoiSitesGenerator | ( |  | ) | `[inline, virtual]`

## Member Function Documentation

virtual void Nv::Blast::VoronoiSitesGenerator::addSite | ( | const NvcVec3 & | site | ) | `[pure virtual]`

Add site in particular point

Parameters:

  `[in]` | site | Site coordinates

Implemented in Nv::Blast::VoronoiSitesGeneratorImpl.

virtual void Nv::Blast::VoronoiSitesGenerator::clearStencil | ( |  | ) | `[pure virtual]`

Removes stencil mesh

Implemented in Nv::Blast::VoronoiSitesGeneratorImpl.

virtual void Nv::Blast::VoronoiSitesGenerator::clusteredSitesGeneration | ( | uint32_t | numberOfClusters,
|  | uint32_t | sitesPerCluster,
|  | float | clusterRadius |
| ) |  |  | `[pure virtual]`

Generate sites in clustered fashion

Parameters:

  `[in]` | numberOfClusters | Number of generated clusters
  `[in]` | sitesPerCluster | Number of sites in each cluster
  `[in]` | clusterRadius | Voronoi cells cluster radius

Implemented in Nv::Blast::VoronoiSitesGeneratorImpl.

virtual void Nv::Blast::VoronoiSitesGenerator::deleteInSphere | ( | const float | radius,
|  | const NvcVec3 & | center,
|  | const float | eraserProbability = `1` |
| ) |  |  | `[pure virtual]`

Deletes sites inside supplied sphere

Parameters:

  `[in]` | radius | Radius of sphere
  `[in]` | center | Center of sphere
  `[in]` | eraserProbability | Probability of removing some particular site

Implemented in Nv::Blast::VoronoiSitesGeneratorImpl.

virtual void Nv::Blast::VoronoiSitesGenerator::generateInSphere | ( | const uint32_t | count,
|  | const float | radius,
|  | const NvcVec3 & | center |
| ) |  |  | `[pure virtual]`

Generate sites inside sphere

Parameters:

  `[in]` | count | Count of generated sites
  `[in]` | radius | Radius of sphere
  `[in]` | center | Center of sphere

Implemented in Nv::Blast::VoronoiSitesGeneratorImpl.

virtual uint32_t Nv::Blast::VoronoiSitesGenerator::getVoronoiSites | ( | const NvcVec3 *& | sites | ) | `[pure virtual]`

Access to generated voronoi sites.

Parameters:

  `[out]` | Pointer | to generated voronoi sites

Returns:
  Count of generated voronoi sites.

Implemented in Nv::Blast::VoronoiSitesGeneratorImpl.

virtual void Nv::Blast::VoronoiSitesGenerator::radialPattern | ( | const NvcVec3 & | center,
|  | const NvcVec3 & | normal,
|  | float | radius,
|  | int32_t | angularSteps,
|  | int32_t | radialSteps,
|  | float | angleOffset = `0.0f`,
|  | float | variability = `0.0f` |
| ) |  |  | `[pure virtual]`

Radial pattern of sites generation

Parameters:

  `[in]` | center | Center of generated pattern
  `[in]` | normal | Normal to plane in which sites are generated
  `[in]` | radius | Pattern radius
  `[in]` | angularSteps | Number of angular steps
  `[in]` | radialSteps | Number of radial steps
  `[in]` | angleOffset | Angle offset at each radial step
  `[in]` | variability | Randomness of sites distribution

Implemented in Nv::Blast::VoronoiSitesGeneratorImpl.

virtual void Nv::Blast::VoronoiSitesGenerator::release | ( |  | ) | `[pure virtual]`

Release VoronoiSitesGenerator memory

Implemented in Nv::Blast::VoronoiSitesGeneratorImpl.

virtual void Nv::Blast::VoronoiSitesGenerator::setBaseMesh | ( | const Mesh * | mesh | ) | `[pure virtual]`

Set base fracture mesh

Implemented in Nv::Blast::VoronoiSitesGeneratorImpl.

virtual void Nv::Blast::VoronoiSitesGenerator::setStencil | ( | const Mesh * | stencil | ) | `[pure virtual]`

Set stencil mesh. With stencil mesh sites are generated only inside both of fracture and stencil meshes.

Parameters:

  `[in]` | stencil | Stencil mesh.

Implemented in Nv::Blast::VoronoiSitesGeneratorImpl.

virtual void Nv::Blast::VoronoiSitesGenerator::uniformlyGenerateSitesInMesh | ( | uint32_t | numberOfSites | ) | `[pure virtual]`

Uniformly generate sites inside the mesh

Parameters:

  `[in]` | numberOfSites | Number of generated sites

Implemented in Nv::Blast::VoronoiSitesGeneratorImpl.

The documentation for this class was generated from the following file:

- sdk/extensions/authoring/include/NvBlastExtAuthoringFractureTool.h